library ws2_32;

uses
  Windows, SysUtils;

type
  TOrgFuncs = record
  case Integer of
    0: (Base: FARPROC;);
    1: (Arr: array [0..194] of FARPROC;);
  end;

const
  SIZE_OF_FUNC = SizeOf(FARPROC);

var
  hl: HINST;
  OrgFuncs: TOrgFuncs;

function GetSysDirectory: String;
begin
  SetLength(Result, MAX_PATH);
  GetSystemDirectoryW(PChar(Result), MAX_PATH);
  SetLength(Result, StrLen(PChar(Result)));
end;

procedure __DLLProc(Reason: Integer);
begin
  case Reason of
    DLL_PROCESS_ATTACH:
    begin
      hl := LoadLibrary(PChar(GetSysDirectory + '\ws2_32.dll'));
      if hl = 0 then Exit;

      OrgFuncs.Arr[0] :=  GetProcAddress(hl, 'accept');
      OrgFuncs.Arr[1] :=  GetProcAddress(hl, 'bind');
      OrgFuncs.Arr[2] :=  GetProcAddress(hl, 'closesocket');
      OrgFuncs.Arr[3] :=  GetProcAddress(hl, 'connect');
      OrgFuncs.Arr[4] :=  GetProcAddress(hl, 'getpeername');
      OrgFuncs.Arr[5] :=  GetProcAddress(hl, 'getsockname');
      OrgFuncs.Arr[6] :=  GetProcAddress(hl, 'getsockopt');
      OrgFuncs.Arr[7] :=  GetProcAddress(hl, 'htonl');
      OrgFuncs.Arr[8] :=  GetProcAddress(hl, 'htons');
      OrgFuncs.Arr[9] :=  GetProcAddress(hl, 'ioctlsocket');
      OrgFuncs.Arr[10] :=  GetProcAddress(hl, 'inet_addr');
      OrgFuncs.Arr[11] :=  GetProcAddress(hl, 'inet_ntoa');
      OrgFuncs.Arr[12] :=  GetProcAddress(hl, 'listen');
      OrgFuncs.Arr[13] :=  GetProcAddress(hl, 'ntohl');
      OrgFuncs.Arr[14] :=  GetProcAddress(hl, 'ntohs');
      OrgFuncs.Arr[15] :=  GetProcAddress(hl, 'recv');
      OrgFuncs.Arr[16] :=  GetProcAddress(hl, 'recvfrom');
      OrgFuncs.Arr[17] :=  GetProcAddress(hl, 'select');
      OrgFuncs.Arr[18] :=  GetProcAddress(hl, 'send');
      OrgFuncs.Arr[19] :=  GetProcAddress(hl, 'sendto');
      OrgFuncs.Arr[20] :=  GetProcAddress(hl, 'setsockopt');
      OrgFuncs.Arr[21] :=  GetProcAddress(hl, 'shutdown');
      OrgFuncs.Arr[22] :=  GetProcAddress(hl, 'socket');
      OrgFuncs.Arr[23] :=  GetProcAddress(hl, 'WSApSetPostRoutine');
      OrgFuncs.Arr[24] :=  GetProcAddress(hl, 'FreeAddrInfoEx');
      OrgFuncs.Arr[25] :=  GetProcAddress(hl, 'FreeAddrInfoExW');
      OrgFuncs.Arr[26] :=  GetProcAddress(hl, 'FreeAddrInfoW');
      OrgFuncs.Arr[27] :=  GetProcAddress(hl, 'GetAddrInfoExA');
      OrgFuncs.Arr[28] :=  GetProcAddress(hl, 'GetAddrInfoExCancel');
      OrgFuncs.Arr[29] :=  GetProcAddress(hl, 'GetAddrInfoExOverlappedResult');
      OrgFuncs.Arr[30] :=  GetProcAddress(hl, 'GetAddrInfoExW');
      OrgFuncs.Arr[31] :=  GetProcAddress(hl, 'GetAddrInfoW');
      OrgFuncs.Arr[32] :=  GetProcAddress(hl, 'GetHostNameW');
      OrgFuncs.Arr[33] :=  GetProcAddress(hl, 'GetNameInfoW');
      OrgFuncs.Arr[34] :=  GetProcAddress(hl, 'InetNtopW');
      OrgFuncs.Arr[35] :=  GetProcAddress(hl, 'InetPtonW');
      OrgFuncs.Arr[36] :=  GetProcAddress(hl, 'SetAddrInfoExA');
      OrgFuncs.Arr[37] :=  GetProcAddress(hl, 'SetAddrInfoExW');
      OrgFuncs.Arr[38] :=  GetProcAddress(hl, 'WPUCompleteOverlappedRequest');
      OrgFuncs.Arr[39] :=  GetProcAddress(hl, 'WPUGetProviderPathEx');
      OrgFuncs.Arr[40] :=  GetProcAddress(hl, 'WSAAccept');
      OrgFuncs.Arr[41] :=  GetProcAddress(hl, 'WSAAddressToStringA');
      OrgFuncs.Arr[42] :=  GetProcAddress(hl, 'WSAAddressToStringW');
      OrgFuncs.Arr[43] :=  GetProcAddress(hl, 'WSAAdvertiseProvider');
      OrgFuncs.Arr[44] :=  GetProcAddress(hl, 'WSACloseEvent');
      OrgFuncs.Arr[45] :=  GetProcAddress(hl, 'WSAConnect');
      OrgFuncs.Arr[46] :=  GetProcAddress(hl, 'WSAConnectByList');
      OrgFuncs.Arr[47] :=  GetProcAddress(hl, 'WSAConnectByNameA');
      OrgFuncs.Arr[48] :=  GetProcAddress(hl, 'WSAConnectByNameW');
      OrgFuncs.Arr[49] :=  GetProcAddress(hl, 'WSACreateEvent');
      OrgFuncs.Arr[50] :=  GetProcAddress(hl, 'gethostbyaddr');
      OrgFuncs.Arr[51] :=  GetProcAddress(hl, 'gethostbyname');
      OrgFuncs.Arr[52] :=  GetProcAddress(hl, 'getprotobyname');
      OrgFuncs.Arr[53] :=  GetProcAddress(hl, 'getprotobynumber');
      OrgFuncs.Arr[54] :=  GetProcAddress(hl, 'getservbyname');
      OrgFuncs.Arr[55] :=  GetProcAddress(hl, 'getservbyport');
      OrgFuncs.Arr[56] :=  GetProcAddress(hl, 'gethostname');
      OrgFuncs.Arr[57] :=  GetProcAddress(hl, 'WSADuplicateSocketA');
      OrgFuncs.Arr[58] :=  GetProcAddress(hl, 'WSADuplicateSocketW');
      OrgFuncs.Arr[59] :=  GetProcAddress(hl, 'WSAEnumNameSpaceProvidersA');
      OrgFuncs.Arr[60] :=  GetProcAddress(hl, 'WSAEnumNameSpaceProvidersExA');
      OrgFuncs.Arr[61] :=  GetProcAddress(hl, 'WSAEnumNameSpaceProvidersExW');
      OrgFuncs.Arr[62] :=  GetProcAddress(hl, 'WSAEnumNameSpaceProvidersW');
      OrgFuncs.Arr[63] :=  GetProcAddress(hl, 'WSAEnumNetworkEvents');
      OrgFuncs.Arr[64] :=  GetProcAddress(hl, 'WSAEnumProtocolsA');
      OrgFuncs.Arr[65] :=  GetProcAddress(hl, 'WSAEnumProtocolsW');
      OrgFuncs.Arr[66] :=  GetProcAddress(hl, 'WSAEventSelect');
      OrgFuncs.Arr[67] :=  GetProcAddress(hl, 'WSAGetOverlappedResult');
      OrgFuncs.Arr[68] :=  GetProcAddress(hl, 'WSAGetQOSByName');
      OrgFuncs.Arr[69] :=  GetProcAddress(hl, 'WSAGetServiceClassInfoA');
      OrgFuncs.Arr[70] :=  GetProcAddress(hl, 'WSAGetServiceClassInfoW');
      OrgFuncs.Arr[71] :=  GetProcAddress(hl, 'WSAGetServiceClassNameByClassIdA');
      OrgFuncs.Arr[72] :=  GetProcAddress(hl, 'WSAGetServiceClassNameByClassIdW');
      OrgFuncs.Arr[73] :=  GetProcAddress(hl, 'WSAHtonl');
      OrgFuncs.Arr[74] :=  GetProcAddress(hl, 'WSAHtons');
      OrgFuncs.Arr[75] :=  GetProcAddress(hl, 'WSAInstallServiceClassA');
      OrgFuncs.Arr[76] :=  GetProcAddress(hl, 'WSAInstallServiceClassW');
      OrgFuncs.Arr[77] :=  GetProcAddress(hl, 'WSAIoctl');
      OrgFuncs.Arr[78] :=  GetProcAddress(hl, 'WSAJoinLeaf');
      OrgFuncs.Arr[79] :=  GetProcAddress(hl, 'WSALookupServiceBeginA');
      OrgFuncs.Arr[80] :=  GetProcAddress(hl, 'WSALookupServiceBeginW');
      OrgFuncs.Arr[81] :=  GetProcAddress(hl, 'WSALookupServiceEnd');
      OrgFuncs.Arr[82] :=  GetProcAddress(hl, 'WSALookupServiceNextA');
      OrgFuncs.Arr[83] :=  GetProcAddress(hl, 'WSALookupServiceNextW');
      OrgFuncs.Arr[84] :=  GetProcAddress(hl, 'WSANSPIoctl');
      OrgFuncs.Arr[85] :=  GetProcAddress(hl, 'WSANtohl');
      OrgFuncs.Arr[86] :=  GetProcAddress(hl, 'WSANtohs');
      OrgFuncs.Arr[87] :=  GetProcAddress(hl, 'WSAPoll');
      OrgFuncs.Arr[88] :=  GetProcAddress(hl, 'WSAProviderCompleteAsyncCall');
      OrgFuncs.Arr[89] :=  GetProcAddress(hl, 'WSAProviderConfigChange');
      OrgFuncs.Arr[90] :=  GetProcAddress(hl, 'WSARecv');
      OrgFuncs.Arr[91] :=  GetProcAddress(hl, 'WSARecvDisconnect');
      OrgFuncs.Arr[92] :=  GetProcAddress(hl, 'WSARecvFrom');
      OrgFuncs.Arr[93] :=  GetProcAddress(hl, 'WSARemoveServiceClass');
      OrgFuncs.Arr[94] :=  GetProcAddress(hl, 'WSAResetEvent');
      OrgFuncs.Arr[95] :=  GetProcAddress(hl, 'WSASend');
      OrgFuncs.Arr[96] :=  GetProcAddress(hl, 'WSASendDisconnect');
      OrgFuncs.Arr[97] :=  GetProcAddress(hl, 'WSASendMsg');
      OrgFuncs.Arr[98] :=  GetProcAddress(hl, 'WSASendTo');
      OrgFuncs.Arr[99] :=  GetProcAddress(hl, 'WSASetEvent');
      OrgFuncs.Arr[100] :=  GetProcAddress(hl, 'WSAAsyncSelect');
      OrgFuncs.Arr[101] :=  GetProcAddress(hl, 'WSAAsyncGetHostByAddr');
      OrgFuncs.Arr[102] :=  GetProcAddress(hl, 'WSAAsyncGetHostByName');
      OrgFuncs.Arr[103] :=  GetProcAddress(hl, 'WSAAsyncGetProtoByNumber');
      OrgFuncs.Arr[104] :=  GetProcAddress(hl, 'WSAAsyncGetProtoByName');
      OrgFuncs.Arr[105] :=  GetProcAddress(hl, 'WSAAsyncGetServByPort');
      OrgFuncs.Arr[106] :=  GetProcAddress(hl, 'WSAAsyncGetServByName');
      OrgFuncs.Arr[107] :=  GetProcAddress(hl, 'WSACancelAsyncRequest');
      OrgFuncs.Arr[108] :=  GetProcAddress(hl, 'WSASetBlockingHook');
      OrgFuncs.Arr[109] :=  GetProcAddress(hl, 'WSAUnhookBlockingHook');
      OrgFuncs.Arr[110] :=  GetProcAddress(hl, 'WSAGetLastError');
      OrgFuncs.Arr[111] :=  GetProcAddress(hl, 'WSASetLastError');
      OrgFuncs.Arr[112] :=  GetProcAddress(hl, 'WSACancelBlockingCall');
      OrgFuncs.Arr[113] :=  GetProcAddress(hl, 'WSAIsBlocking');
      OrgFuncs.Arr[114] :=  GetProcAddress(hl, 'WSAStartup');
      OrgFuncs.Arr[115] :=  GetProcAddress(hl, 'WSACleanup');
      OrgFuncs.Arr[116] :=  GetProcAddress(hl, 'WSASetServiceA');
      OrgFuncs.Arr[117] :=  GetProcAddress(hl, 'WSASetServiceW');
      OrgFuncs.Arr[118] :=  GetProcAddress(hl, 'WSASocketA');
      OrgFuncs.Arr[119] :=  GetProcAddress(hl, 'WSASocketW');
      OrgFuncs.Arr[120] :=  GetProcAddress(hl, 'WSAStringToAddressA');
      OrgFuncs.Arr[121] :=  GetProcAddress(hl, 'WSAStringToAddressW');
      OrgFuncs.Arr[122] :=  GetProcAddress(hl, 'WSAUnadvertiseProvider');
      OrgFuncs.Arr[123] :=  GetProcAddress(hl, 'WSAWaitForMultipleEvents');
      OrgFuncs.Arr[124] :=  GetProcAddress(hl, 'WSCDeinstallProvider');
      OrgFuncs.Arr[125] :=  GetProcAddress(hl, 'WSCDeinstallProvider32');
      OrgFuncs.Arr[126] :=  GetProcAddress(hl, 'WSCDeinstallProviderEx');
      OrgFuncs.Arr[127] :=  GetProcAddress(hl, 'WSCEnableNSProvider');
      OrgFuncs.Arr[128] :=  GetProcAddress(hl, 'WSCEnableNSProvider32');
      OrgFuncs.Arr[129] :=  GetProcAddress(hl, 'WSCEnumNameSpaceProviders32');
      OrgFuncs.Arr[130] :=  GetProcAddress(hl, 'WSCEnumNameSpaceProvidersEx32');
      OrgFuncs.Arr[131] :=  GetProcAddress(hl, 'WSCEnumProtocols');
      OrgFuncs.Arr[132] :=  GetProcAddress(hl, 'WSCEnumProtocols32');
      OrgFuncs.Arr[133] :=  GetProcAddress(hl, 'WSCEnumProtocolsEx');
      OrgFuncs.Arr[134] :=  GetProcAddress(hl, 'WSCGetApplicationCategory');
      OrgFuncs.Arr[135] :=  GetProcAddress(hl, 'WSCGetApplicationCategoryEx');
      OrgFuncs.Arr[136] :=  GetProcAddress(hl, 'WSCGetProviderInfo');
      OrgFuncs.Arr[137] :=  GetProcAddress(hl, 'WSCGetProviderInfo32');
      OrgFuncs.Arr[138] :=  GetProcAddress(hl, 'WSCGetProviderPath');
      OrgFuncs.Arr[139] :=  GetProcAddress(hl, 'WSCGetProviderPath32');
      OrgFuncs.Arr[140] :=  GetProcAddress(hl, 'WSCInstallNameSpace');
      OrgFuncs.Arr[141] :=  GetProcAddress(hl, 'WSCInstallNameSpace32');
      OrgFuncs.Arr[142] :=  GetProcAddress(hl, 'WSCInstallNameSpaceEx');
      OrgFuncs.Arr[143] :=  GetProcAddress(hl, 'WSCInstallNameSpaceEx2');
      OrgFuncs.Arr[144] :=  GetProcAddress(hl, 'WSCInstallNameSpaceEx32');
      OrgFuncs.Arr[145] :=  GetProcAddress(hl, 'WSCInstallProvider');
      OrgFuncs.Arr[146] :=  GetProcAddress(hl, 'WSCInstallProvider64_32');
      OrgFuncs.Arr[147] :=  GetProcAddress(hl, 'WSCInstallProviderAndChains64_32');
      OrgFuncs.Arr[148] :=  GetProcAddress(hl, 'WSCInstallProviderEx');
      OrgFuncs.Arr[149] :=  GetProcAddress(hl, 'WSCSetApplicationCategory');
      OrgFuncs.Arr[150] :=  GetProcAddress(hl, '__WSAFDIsSet');
      OrgFuncs.Arr[151] :=  GetProcAddress(hl, 'WSCSetApplicationCategoryEx');
      OrgFuncs.Arr[152] :=  GetProcAddress(hl, 'WSCSetProviderInfo');
      OrgFuncs.Arr[153] :=  GetProcAddress(hl, 'WSCSetProviderInfo32');
      OrgFuncs.Arr[154] :=  GetProcAddress(hl, 'WSCUnInstallNameSpace');
      OrgFuncs.Arr[155] :=  GetProcAddress(hl, 'WSCUnInstallNameSpace32');
      OrgFuncs.Arr[156] :=  GetProcAddress(hl, 'WSCUnInstallNameSpaceEx2');
      OrgFuncs.Arr[157] :=  GetProcAddress(hl, 'WSCUpdateProvider');
      OrgFuncs.Arr[158] :=  GetProcAddress(hl, 'WSCUpdateProvider32');
      OrgFuncs.Arr[159] :=  GetProcAddress(hl, 'WSCUpdateProviderEx');
      OrgFuncs.Arr[160] :=  GetProcAddress(hl, 'WSCWriteNameSpaceOrder');
      OrgFuncs.Arr[161] :=  GetProcAddress(hl, 'WSCWriteNameSpaceOrder32');
      OrgFuncs.Arr[162] :=  GetProcAddress(hl, 'WSCWriteProviderOrder');
      OrgFuncs.Arr[163] :=  GetProcAddress(hl, 'WSCWriteProviderOrder32');
      OrgFuncs.Arr[164] :=  GetProcAddress(hl, 'WSCWriteProviderOrderEx');
      OrgFuncs.Arr[165] :=  GetProcAddress(hl, 'WahCloseApcHelper');
      OrgFuncs.Arr[166] :=  GetProcAddress(hl, 'WahCloseHandleHelper');
      OrgFuncs.Arr[167] :=  GetProcAddress(hl, 'WahCloseNotificationHandleHelper');
      OrgFuncs.Arr[168] :=  GetProcAddress(hl, 'WahCloseSocketHandle');
      OrgFuncs.Arr[169] :=  GetProcAddress(hl, 'WahCloseThread');
      OrgFuncs.Arr[170] :=  GetProcAddress(hl, 'WahCompleteRequest');
      OrgFuncs.Arr[171] :=  GetProcAddress(hl, 'WahCreateHandleContextTable');
      OrgFuncs.Arr[172] :=  GetProcAddress(hl, 'WahCreateNotificationHandle');
      OrgFuncs.Arr[173] :=  GetProcAddress(hl, 'WahCreateSocketHandle');
      OrgFuncs.Arr[174] :=  GetProcAddress(hl, 'WahDestroyHandleContextTable');
      OrgFuncs.Arr[175] :=  GetProcAddress(hl, 'WahDisableNonIFSHandleSupport');
      OrgFuncs.Arr[176] :=  GetProcAddress(hl, 'WahEnableNonIFSHandleSupport');
      OrgFuncs.Arr[177] :=  GetProcAddress(hl, 'WahEnumerateHandleContexts');
      OrgFuncs.Arr[178] :=  GetProcAddress(hl, 'WahInsertHandleContext');
      OrgFuncs.Arr[179] :=  GetProcAddress(hl, 'WahNotifyAllProcesses');
      OrgFuncs.Arr[180] :=  GetProcAddress(hl, 'WahOpenApcHelper');
      OrgFuncs.Arr[181] :=  GetProcAddress(hl, 'WahOpenCurrentThread');
      OrgFuncs.Arr[182] :=  GetProcAddress(hl, 'WahOpenHandleHelper');
      OrgFuncs.Arr[183] :=  GetProcAddress(hl, 'WahOpenNotificationHandleHelper');
      OrgFuncs.Arr[184] :=  GetProcAddress(hl, 'WahQueueUserApc');
      OrgFuncs.Arr[185] :=  GetProcAddress(hl, 'WahReferenceContextByHandle');
      OrgFuncs.Arr[186] :=  GetProcAddress(hl, 'WahRemoveHandleContext');
      OrgFuncs.Arr[187] :=  GetProcAddress(hl, 'WahWaitForNotification');
      OrgFuncs.Arr[188] :=  GetProcAddress(hl, 'WahWriteLSPEvent');
      OrgFuncs.Arr[189] :=  GetProcAddress(hl, 'freeaddrinfo');
      OrgFuncs.Arr[190] :=  GetProcAddress(hl, 'getaddrinfo');
      OrgFuncs.Arr[191] :=  GetProcAddress(hl, 'getnameinfo');
      OrgFuncs.Arr[192] :=  GetProcAddress(hl, 'inet_ntop');
      OrgFuncs.Arr[193] :=  GetProcAddress(hl, 'inet_pton');
      OrgFuncs.Arr[194] :=  GetProcAddress(hl, 'WEP');

    end;

    DLL_PROCESS_DETACH:
    begin
      FreeLibrary(hl);
    end;
  end;
end;

// accept
procedure __E__0__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 0]
end;


// bind
procedure __E__1__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 1]
end;


// closesocket
procedure __E__2__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 2]
end;


// connect
procedure __E__3__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 3]
end;


// getpeername
procedure __E__4__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 4]
end;


// getsockname
procedure __E__5__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 5]
end;


// getsockopt
procedure __E__6__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 6]
end;


// htonl
procedure __E__7__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 7]
end;


// htons
procedure __E__8__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 8]
end;


// ioctlsocket
procedure __E__9__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 9]
end;


// inet_addr
procedure __E__10__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 10]
end;


// inet_ntoa
procedure __E__11__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 11]
end;


// listen
procedure __E__12__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 12]
end;


// ntohl
procedure __E__13__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 13]
end;


// ntohs
procedure __E__14__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 14]
end;


// recv
procedure __E__15__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 15]
end;


// recvfrom
procedure __E__16__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 16]
end;


// select
procedure __E__17__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 17]
end;


// send
procedure __E__18__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 18]
end;


// sendto
procedure __E__19__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 19]
end;


// setsockopt
procedure __E__20__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 20]
end;


// shutdown
procedure __E__21__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 21]
end;


// socket
procedure __E__22__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 22]
end;


// WSApSetPostRoutine
procedure __E__23__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 23]
end;


// FreeAddrInfoEx
procedure __E__24__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 24]
end;


// FreeAddrInfoExW
procedure __E__25__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 25]
end;


// FreeAddrInfoW
procedure __E__26__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 26]
end;


// GetAddrInfoExA
procedure __E__27__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 27]
end;


// GetAddrInfoExCancel
procedure __E__28__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 28]
end;


// GetAddrInfoExOverlappedResult
procedure __E__29__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 29]
end;


// GetAddrInfoExW
procedure __E__30__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 30]
end;


// GetAddrInfoW
procedure __E__31__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 31]
end;


// GetHostNameW
procedure __E__32__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 32]
end;


// GetNameInfoW
procedure __E__33__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 33]
end;


// InetNtopW
procedure __E__34__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 34]
end;


// InetPtonW
procedure __E__35__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 35]
end;


// SetAddrInfoExA
procedure __E__36__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 36]
end;


// SetAddrInfoExW
procedure __E__37__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 37]
end;


// WPUCompleteOverlappedRequest
procedure __E__38__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 38]
end;


// WPUGetProviderPathEx
procedure __E__39__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 39]
end;


// WSAAccept
procedure __E__40__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 40]
end;


// WSAAddressToStringA
procedure __E__41__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 41]
end;


// WSAAddressToStringW
procedure __E__42__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 42]
end;


// WSAAdvertiseProvider
procedure __E__43__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 43]
end;


// WSACloseEvent
procedure __E__44__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 44]
end;


// WSAConnect
procedure __E__45__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 45]
end;


// WSAConnectByList
procedure __E__46__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 46]
end;


// WSAConnectByNameA
procedure __E__47__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 47]
end;


// WSAConnectByNameW
procedure __E__48__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 48]
end;


// WSACreateEvent
procedure __E__49__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 49]
end;


// gethostbyaddr
procedure __E__50__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 50]
end;


// gethostbyname
procedure __E__51__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 51]
end;


// getprotobyname
procedure __E__52__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 52]
end;


// getprotobynumber
procedure __E__53__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 53]
end;


// getservbyname
procedure __E__54__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 54]
end;


// getservbyport
procedure __E__55__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 55]
end;


// gethostname
procedure __E__56__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 56]
end;


// WSADuplicateSocketA
procedure __E__57__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 57]
end;


// WSADuplicateSocketW
procedure __E__58__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 58]
end;


// WSAEnumNameSpaceProvidersA
procedure __E__59__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 59]
end;


// WSAEnumNameSpaceProvidersExA
procedure __E__60__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 60]
end;


// WSAEnumNameSpaceProvidersExW
procedure __E__61__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 61]
end;


// WSAEnumNameSpaceProvidersW
procedure __E__62__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 62]
end;


// WSAEnumNetworkEvents
procedure __E__63__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 63]
end;


// WSAEnumProtocolsA
procedure __E__64__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 64]
end;


// WSAEnumProtocolsW
procedure __E__65__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 65]
end;


// WSAEventSelect
procedure __E__66__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 66]
end;


// WSAGetOverlappedResult
procedure __E__67__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 67]
end;


// WSAGetQOSByName
procedure __E__68__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 68]
end;


// WSAGetServiceClassInfoA
procedure __E__69__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 69]
end;


// WSAGetServiceClassInfoW
procedure __E__70__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 70]
end;


// WSAGetServiceClassNameByClassIdA
procedure __E__71__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 71]
end;


// WSAGetServiceClassNameByClassIdW
procedure __E__72__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 72]
end;


// WSAHtonl
procedure __E__73__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 73]
end;


// WSAHtons
procedure __E__74__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 74]
end;


// WSAInstallServiceClassA
procedure __E__75__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 75]
end;


// WSAInstallServiceClassW
procedure __E__76__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 76]
end;


// WSAIoctl
procedure __E__77__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 77]
end;


// WSAJoinLeaf
procedure __E__78__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 78]
end;


// WSALookupServiceBeginA
procedure __E__79__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 79]
end;


// WSALookupServiceBeginW
procedure __E__80__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 80]
end;


// WSALookupServiceEnd
procedure __E__81__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 81]
end;


// WSALookupServiceNextA
procedure __E__82__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 82]
end;


// WSALookupServiceNextW
procedure __E__83__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 83]
end;


// WSANSPIoctl
procedure __E__84__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 84]
end;


// WSANtohl
procedure __E__85__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 85]
end;


// WSANtohs
procedure __E__86__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 86]
end;


// WSAPoll
procedure __E__87__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 87]
end;


// WSAProviderCompleteAsyncCall
procedure __E__88__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 88]
end;


// WSAProviderConfigChange
procedure __E__89__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 89]
end;


// WSARecv
procedure __E__90__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 90]
end;


// WSARecvDisconnect
procedure __E__91__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 91]
end;


// WSARecvFrom
procedure __E__92__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 92]
end;


// WSARemoveServiceClass
procedure __E__93__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 93]
end;


// WSAResetEvent
procedure __E__94__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 94]
end;


// WSASend
procedure __E__95__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 95]
end;


// WSASendDisconnect
procedure __E__96__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 96]
end;


// WSASendMsg
procedure __E__97__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 97]
end;


// WSASendTo
procedure __E__98__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 98]
end;


// WSASetEvent
procedure __E__99__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 99]
end;


// WSAAsyncSelect
procedure __E__100__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 100]
end;


// WSAAsyncGetHostByAddr
procedure __E__101__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 101]
end;


// WSAAsyncGetHostByName
procedure __E__102__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 102]
end;


// WSAAsyncGetProtoByNumber
procedure __E__103__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 103]
end;


// WSAAsyncGetProtoByName
procedure __E__104__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 104]
end;


// WSAAsyncGetServByPort
procedure __E__105__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 105]
end;


// WSAAsyncGetServByName
procedure __E__106__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 106]
end;


// WSACancelAsyncRequest
procedure __E__107__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 107]
end;


// WSASetBlockingHook
procedure __E__108__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 108]
end;


// WSAUnhookBlockingHook
procedure __E__109__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 109]
end;


// WSAGetLastError
procedure __E__110__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 110]
end;


// WSASetLastError
procedure __E__111__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 111]
end;


// WSACancelBlockingCall
procedure __E__112__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 112]
end;


// WSAIsBlocking
procedure __E__113__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 113]
end;


// WSAStartup
procedure __E__114__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 114]
end;


// WSACleanup
procedure __E__115__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 115]
end;


// WSASetServiceA
procedure __E__116__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 116]
end;


// WSASetServiceW
procedure __E__117__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 117]
end;


// WSASocketA
procedure __E__118__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 118]
end;


// WSASocketW
procedure __E__119__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 119]
end;


// WSAStringToAddressA
procedure __E__120__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 120]
end;


// WSAStringToAddressW
procedure __E__121__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 121]
end;


// WSAUnadvertiseProvider
procedure __E__122__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 122]
end;


// WSAWaitForMultipleEvents
procedure __E__123__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 123]
end;


// WSCDeinstallProvider
procedure __E__124__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 124]
end;


// WSCDeinstallProvider32
procedure __E__125__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 125]
end;


// WSCDeinstallProviderEx
procedure __E__126__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 126]
end;


// WSCEnableNSProvider
procedure __E__127__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 127]
end;


// WSCEnableNSProvider32
procedure __E__128__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 128]
end;


// WSCEnumNameSpaceProviders32
procedure __E__129__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 129]
end;


// WSCEnumNameSpaceProvidersEx32
procedure __E__130__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 130]
end;


// WSCEnumProtocols
procedure __E__131__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 131]
end;


// WSCEnumProtocols32
procedure __E__132__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 132]
end;


// WSCEnumProtocolsEx
procedure __E__133__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 133]
end;


// WSCGetApplicationCategory
procedure __E__134__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 134]
end;


// WSCGetApplicationCategoryEx
procedure __E__135__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 135]
end;


// WSCGetProviderInfo
procedure __E__136__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 136]
end;


// WSCGetProviderInfo32
procedure __E__137__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 137]
end;


// WSCGetProviderPath
procedure __E__138__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 138]
end;


// WSCGetProviderPath32
procedure __E__139__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 139]
end;


// WSCInstallNameSpace
procedure __E__140__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 140]
end;


// WSCInstallNameSpace32
procedure __E__141__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 141]
end;


// WSCInstallNameSpaceEx
procedure __E__142__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 142]
end;


// WSCInstallNameSpaceEx2
procedure __E__143__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 143]
end;


// WSCInstallNameSpaceEx32
procedure __E__144__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 144]
end;


// WSCInstallProvider
procedure __E__145__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 145]
end;


// WSCInstallProvider64_32
procedure __E__146__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 146]
end;


// WSCInstallProviderAndChains64_32
procedure __E__147__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 147]
end;


// WSCInstallProviderEx
procedure __E__148__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 148]
end;


// WSCSetApplicationCategory
procedure __E__149__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 149]
end;


// __WSAFDIsSet
procedure __E__150__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 150]
end;


// WSCSetApplicationCategoryEx
procedure __E__151__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 151]
end;


// WSCSetProviderInfo
procedure __E__152__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 152]
end;


// WSCSetProviderInfo32
procedure __E__153__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 153]
end;


// WSCUnInstallNameSpace
procedure __E__154__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 154]
end;


// WSCUnInstallNameSpace32
procedure __E__155__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 155]
end;


// WSCUnInstallNameSpaceEx2
procedure __E__156__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 156]
end;


// WSCUpdateProvider
procedure __E__157__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 157]
end;


// WSCUpdateProvider32
procedure __E__158__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 158]
end;


// WSCUpdateProviderEx
procedure __E__159__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 159]
end;


// WSCWriteNameSpaceOrder
procedure __E__160__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 160]
end;


// WSCWriteNameSpaceOrder32
procedure __E__161__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 161]
end;


// WSCWriteProviderOrder
procedure __E__162__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 162]
end;


// WSCWriteProviderOrder32
procedure __E__163__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 163]
end;


// WSCWriteProviderOrderEx
procedure __E__164__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 164]
end;


// WahCloseApcHelper
procedure __E__165__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 165]
end;


// WahCloseHandleHelper
procedure __E__166__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 166]
end;


// WahCloseNotificationHandleHelper
procedure __E__167__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 167]
end;


// WahCloseSocketHandle
procedure __E__168__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 168]
end;


// WahCloseThread
procedure __E__169__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 169]
end;


// WahCompleteRequest
procedure __E__170__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 170]
end;


// WahCreateHandleContextTable
procedure __E__171__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 171]
end;


// WahCreateNotificationHandle
procedure __E__172__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 172]
end;


// WahCreateSocketHandle
procedure __E__173__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 173]
end;


// WahDestroyHandleContextTable
procedure __E__174__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 174]
end;


// WahDisableNonIFSHandleSupport
procedure __E__175__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 175]
end;


// WahEnableNonIFSHandleSupport
procedure __E__176__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 176]
end;


// WahEnumerateHandleContexts
procedure __E__177__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 177]
end;


// WahInsertHandleContext
procedure __E__178__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 178]
end;


// WahNotifyAllProcesses
procedure __E__179__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 179]
end;


// WahOpenApcHelper
procedure __E__180__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 180]
end;


// WahOpenCurrentThread
procedure __E__181__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 181]
end;


// WahOpenHandleHelper
procedure __E__182__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 182]
end;


// WahOpenNotificationHandleHelper
procedure __E__183__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 183]
end;


// WahQueueUserApc
procedure __E__184__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 184]
end;


// WahReferenceContextByHandle
procedure __E__185__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 185]
end;


// WahRemoveHandleContext
procedure __E__186__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 186]
end;


// WahWaitForNotification
procedure __E__187__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 187]
end;


// WahWriteLSPEvent
procedure __E__188__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 188]
end;


// freeaddrinfo
procedure __E__189__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 189]
end;


// getaddrinfo
procedure __E__190__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 190]
end;


// getnameinfo
procedure __E__191__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 191]
end;


// inet_ntop
procedure __E__192__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 192]
end;


// inet_pton
procedure __E__193__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 193]
end;


// WEP
procedure __E__194__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 194]
end;




//-------- Exports
exports
  __E__0__ index 1 name 'accept',
  __E__1__ index 2 name 'bind',
  __E__2__ index 3 name 'closesocket',
  __E__3__ index 4 name 'connect',
  __E__4__ index 5 name 'getpeername',
  __E__5__ index 6 name 'getsockname',
  __E__6__ index 7 name 'getsockopt',
  __E__7__ index 8 name 'htonl',
  __E__8__ index 9 name 'htons',
  __E__9__ index 10 name 'ioctlsocket',
  __E__10__ index 11 name 'inet_addr',
  __E__11__ index 12 name 'inet_ntoa',
  __E__12__ index 13 name 'listen',
  __E__13__ index 14 name 'ntohl',
  __E__14__ index 15 name 'ntohs',
  __E__15__ index 16 name 'recv',
  __E__16__ index 17 name 'recvfrom',
  __E__17__ index 18 name 'select',
  __E__18__ index 19 name 'send',
  __E__19__ index 20 name 'sendto',
  __E__20__ index 21 name 'setsockopt',
  __E__21__ index 22 name 'shutdown',
  __E__22__ index 23 name 'socket',
  __E__23__ index 24 name 'WSApSetPostRoutine',
  __E__24__ index 25 name 'FreeAddrInfoEx',
  __E__25__ index 26 name 'FreeAddrInfoExW',
  __E__26__ index 27 name 'FreeAddrInfoW',
  __E__27__ index 28 name 'GetAddrInfoExA',
  __E__28__ index 29 name 'GetAddrInfoExCancel',
  __E__29__ index 30 name 'GetAddrInfoExOverlappedResult',
  __E__30__ index 31 name 'GetAddrInfoExW',
  __E__31__ index 32 name 'GetAddrInfoW',
  __E__32__ index 33 name 'GetHostNameW',
  __E__33__ index 34 name 'GetNameInfoW',
  __E__34__ index 35 name 'InetNtopW',
  __E__35__ index 36 name 'InetPtonW',
  __E__36__ index 37 name 'SetAddrInfoExA',
  __E__37__ index 38 name 'SetAddrInfoExW',
  __E__38__ index 39 name 'WPUCompleteOverlappedRequest',
  __E__39__ index 40 name 'WPUGetProviderPathEx',
  __E__40__ index 41 name 'WSAAccept',
  __E__41__ index 42 name 'WSAAddressToStringA',
  __E__42__ index 43 name 'WSAAddressToStringW',
  __E__43__ index 44 name 'WSAAdvertiseProvider',
  __E__44__ index 45 name 'WSACloseEvent',
  __E__45__ index 46 name 'WSAConnect',
  __E__46__ index 47 name 'WSAConnectByList',
  __E__47__ index 48 name 'WSAConnectByNameA',
  __E__48__ index 49 name 'WSAConnectByNameW',
  __E__49__ index 50 name 'WSACreateEvent',
  __E__50__ index 51 name 'gethostbyaddr',
  __E__51__ index 52 name 'gethostbyname',
  __E__52__ index 53 name 'getprotobyname',
  __E__53__ index 54 name 'getprotobynumber',
  __E__54__ index 55 name 'getservbyname',
  __E__55__ index 56 name 'getservbyport',
  __E__56__ index 57 name 'gethostname',
  __E__57__ index 58 name 'WSADuplicateSocketA',
  __E__58__ index 59 name 'WSADuplicateSocketW',
  __E__59__ index 60 name 'WSAEnumNameSpaceProvidersA',
  __E__60__ index 61 name 'WSAEnumNameSpaceProvidersExA',
  __E__61__ index 62 name 'WSAEnumNameSpaceProvidersExW',
  __E__62__ index 63 name 'WSAEnumNameSpaceProvidersW',
  __E__63__ index 64 name 'WSAEnumNetworkEvents',
  __E__64__ index 65 name 'WSAEnumProtocolsA',
  __E__65__ index 66 name 'WSAEnumProtocolsW',
  __E__66__ index 67 name 'WSAEventSelect',
  __E__67__ index 68 name 'WSAGetOverlappedResult',
  __E__68__ index 69 name 'WSAGetQOSByName',
  __E__69__ index 70 name 'WSAGetServiceClassInfoA',
  __E__70__ index 71 name 'WSAGetServiceClassInfoW',
  __E__71__ index 72 name 'WSAGetServiceClassNameByClassIdA',
  __E__72__ index 73 name 'WSAGetServiceClassNameByClassIdW',
  __E__73__ index 74 name 'WSAHtonl',
  __E__74__ index 75 name 'WSAHtons',
  __E__75__ index 76 name 'WSAInstallServiceClassA',
  __E__76__ index 77 name 'WSAInstallServiceClassW',
  __E__77__ index 78 name 'WSAIoctl',
  __E__78__ index 79 name 'WSAJoinLeaf',
  __E__79__ index 80 name 'WSALookupServiceBeginA',
  __E__80__ index 81 name 'WSALookupServiceBeginW',
  __E__81__ index 82 name 'WSALookupServiceEnd',
  __E__82__ index 83 name 'WSALookupServiceNextA',
  __E__83__ index 84 name 'WSALookupServiceNextW',
  __E__84__ index 85 name 'WSANSPIoctl',
  __E__85__ index 86 name 'WSANtohl',
  __E__86__ index 87 name 'WSANtohs',
  __E__87__ index 88 name 'WSAPoll',
  __E__88__ index 89 name 'WSAProviderCompleteAsyncCall',
  __E__89__ index 90 name 'WSAProviderConfigChange',
  __E__90__ index 91 name 'WSARecv',
  __E__91__ index 92 name 'WSARecvDisconnect',
  __E__92__ index 93 name 'WSARecvFrom',
  __E__93__ index 94 name 'WSARemoveServiceClass',
  __E__94__ index 95 name 'WSAResetEvent',
  __E__95__ index 96 name 'WSASend',
  __E__96__ index 97 name 'WSASendDisconnect',
  __E__97__ index 98 name 'WSASendMsg',
  __E__98__ index 99 name 'WSASendTo',
  __E__99__ index 100 name 'WSASetEvent',
  __E__100__ index 101 name 'WSAAsyncSelect',
  __E__101__ index 102 name 'WSAAsyncGetHostByAddr',
  __E__102__ index 103 name 'WSAAsyncGetHostByName',
  __E__103__ index 104 name 'WSAAsyncGetProtoByNumber',
  __E__104__ index 105 name 'WSAAsyncGetProtoByName',
  __E__105__ index 106 name 'WSAAsyncGetServByPort',
  __E__106__ index 107 name 'WSAAsyncGetServByName',
  __E__107__ index 108 name 'WSACancelAsyncRequest',
  __E__108__ index 109 name 'WSASetBlockingHook',
  __E__109__ index 110 name 'WSAUnhookBlockingHook',
  __E__110__ index 111 name 'WSAGetLastError',
  __E__111__ index 112 name 'WSASetLastError',
  __E__112__ index 113 name 'WSACancelBlockingCall',
  __E__113__ index 114 name 'WSAIsBlocking',
  __E__114__ index 115 name 'WSAStartup',
  __E__115__ index 116 name 'WSACleanup',
  __E__116__ index 117 name 'WSASetServiceA',
  __E__117__ index 118 name 'WSASetServiceW',
  __E__118__ index 119 name 'WSASocketA',
  __E__119__ index 120 name 'WSASocketW',
  __E__120__ index 121 name 'WSAStringToAddressA',
  __E__121__ index 122 name 'WSAStringToAddressW',
  __E__122__ index 123 name 'WSAUnadvertiseProvider',
  __E__123__ index 124 name 'WSAWaitForMultipleEvents',
  __E__124__ index 125 name 'WSCDeinstallProvider',
  __E__125__ index 126 name 'WSCDeinstallProvider32',
  __E__126__ index 127 name 'WSCDeinstallProviderEx',
  __E__127__ index 128 name 'WSCEnableNSProvider',
  __E__128__ index 129 name 'WSCEnableNSProvider32',
  __E__129__ index 130 name 'WSCEnumNameSpaceProviders32',
  __E__130__ index 131 name 'WSCEnumNameSpaceProvidersEx32',
  __E__131__ index 132 name 'WSCEnumProtocols',
  __E__132__ index 133 name 'WSCEnumProtocols32',
  __E__133__ index 134 name 'WSCEnumProtocolsEx',
  __E__134__ index 135 name 'WSCGetApplicationCategory',
  __E__135__ index 136 name 'WSCGetApplicationCategoryEx',
  __E__136__ index 137 name 'WSCGetProviderInfo',
  __E__137__ index 138 name 'WSCGetProviderInfo32',
  __E__138__ index 139 name 'WSCGetProviderPath',
  __E__139__ index 140 name 'WSCGetProviderPath32',
  __E__140__ index 141 name 'WSCInstallNameSpace',
  __E__141__ index 142 name 'WSCInstallNameSpace32',
  __E__142__ index 143 name 'WSCInstallNameSpaceEx',
  __E__143__ index 144 name 'WSCInstallNameSpaceEx2',
  __E__144__ index 145 name 'WSCInstallNameSpaceEx32',
  __E__145__ index 146 name 'WSCInstallProvider',
  __E__146__ index 147 name 'WSCInstallProvider64_32',
  __E__147__ index 148 name 'WSCInstallProviderAndChains64_32',
  __E__148__ index 149 name 'WSCInstallProviderEx',
  __E__149__ index 150 name 'WSCSetApplicationCategory',
  __E__150__ index 151 name '__WSAFDIsSet',
  __E__151__ index 152 name 'WSCSetApplicationCategoryEx',
  __E__152__ index 153 name 'WSCSetProviderInfo',
  __E__153__ index 154 name 'WSCSetProviderInfo32',
  __E__154__ index 155 name 'WSCUnInstallNameSpace',
  __E__155__ index 156 name 'WSCUnInstallNameSpace32',
  __E__156__ index 157 name 'WSCUnInstallNameSpaceEx2',
  __E__157__ index 158 name 'WSCUpdateProvider',
  __E__158__ index 159 name 'WSCUpdateProvider32',
  __E__159__ index 160 name 'WSCUpdateProviderEx',
  __E__160__ index 161 name 'WSCWriteNameSpaceOrder',
  __E__161__ index 162 name 'WSCWriteNameSpaceOrder32',
  __E__162__ index 163 name 'WSCWriteProviderOrder',
  __E__163__ index 164 name 'WSCWriteProviderOrder32',
  __E__164__ index 165 name 'WSCWriteProviderOrderEx',
  __E__165__ index 166 name 'WahCloseApcHelper',
  __E__166__ index 167 name 'WahCloseHandleHelper',
  __E__167__ index 168 name 'WahCloseNotificationHandleHelper',
  __E__168__ index 169 name 'WahCloseSocketHandle',
  __E__169__ index 170 name 'WahCloseThread',
  __E__170__ index 171 name 'WahCompleteRequest',
  __E__171__ index 172 name 'WahCreateHandleContextTable',
  __E__172__ index 173 name 'WahCreateNotificationHandle',
  __E__173__ index 174 name 'WahCreateSocketHandle',
  __E__174__ index 175 name 'WahDestroyHandleContextTable',
  __E__175__ index 176 name 'WahDisableNonIFSHandleSupport',
  __E__176__ index 177 name 'WahEnableNonIFSHandleSupport',
  __E__177__ index 178 name 'WahEnumerateHandleContexts',
  __E__178__ index 179 name 'WahInsertHandleContext',
  __E__179__ index 180 name 'WahNotifyAllProcesses',
  __E__180__ index 181 name 'WahOpenApcHelper',
  __E__181__ index 182 name 'WahOpenCurrentThread',
  __E__182__ index 183 name 'WahOpenHandleHelper',
  __E__183__ index 184 name 'WahOpenNotificationHandleHelper',
  __E__184__ index 185 name 'WahQueueUserApc',
  __E__185__ index 186 name 'WahReferenceContextByHandle',
  __E__186__ index 187 name 'WahRemoveHandleContext',
  __E__187__ index 188 name 'WahWaitForNotification',
  __E__188__ index 189 name 'WahWriteLSPEvent',
  __E__189__ index 190 name 'freeaddrinfo',
  __E__190__ index 191 name 'getaddrinfo',
  __E__191__ index 192 name 'getnameinfo',
  __E__192__ index 193 name 'inet_ntop',
  __E__193__ index 194 name 'inet_pton',
  __E__194__ index 500 name 'WEP';


begin
  DllProc := __DLLProc;
  __DLLProc(DLL_PROCESS_ATTACH);
end.
