library wsock32;

uses
  Windows, SysUtils;

type
  TOrgFuncs = record
  case Integer of
    0: (Base: FARPROC;);
    1: (Arr: array [0..74] of FARPROC;);
  end;

const
  SIZE_OF_FUNC = SizeOf(FARPROC);

var
  hl: HINST;
  OrgFuncs: TOrgFuncs;

function GetSysDirectory: String;
begin
  SetLength(Result, MAX_PATH);
  GetSystemDirectoryW(PChar(Result), MAX_PATH);
  SetLength(Result, StrLen(PChar(Result)));
end;

procedure __DLLProc(Reason: Integer);
begin
  case Reason of
    DLL_PROCESS_ATTACH:
    begin
      hl := LoadLibrary(PChar(GetSysDirectory + '\wsock32.dll'));
      if hl = 0 then Exit;

      OrgFuncs.Arr[0] :=  GetProcAddress(hl, 'accept');
      OrgFuncs.Arr[1] :=  GetProcAddress(hl, 'bind');
      OrgFuncs.Arr[2] :=  GetProcAddress(hl, 'closesocket');
      OrgFuncs.Arr[3] :=  GetProcAddress(hl, 'connect');
      OrgFuncs.Arr[4] :=  GetProcAddress(hl, 'getpeername');
      OrgFuncs.Arr[5] :=  GetProcAddress(hl, 'getsockname');
      OrgFuncs.Arr[6] :=  GetProcAddress(hl, 'getsockopt');
      OrgFuncs.Arr[7] :=  GetProcAddress(hl, 'htonl');
      OrgFuncs.Arr[8] :=  GetProcAddress(hl, 'htons');
      OrgFuncs.Arr[9] :=  GetProcAddress(hl, 'inet_addr');
      OrgFuncs.Arr[10] :=  GetProcAddress(hl, 'inet_ntoa');
      OrgFuncs.Arr[11] :=  GetProcAddress(hl, 'ioctlsocket');
      OrgFuncs.Arr[12] :=  GetProcAddress(hl, 'listen');
      OrgFuncs.Arr[13] :=  GetProcAddress(hl, 'ntohl');
      OrgFuncs.Arr[14] :=  GetProcAddress(hl, 'ntohs');
      OrgFuncs.Arr[15] :=  GetProcAddress(hl, 'recv');
      OrgFuncs.Arr[16] :=  GetProcAddress(hl, 'recvfrom');
      OrgFuncs.Arr[17] :=  GetProcAddress(hl, 'select');
      OrgFuncs.Arr[18] :=  GetProcAddress(hl, 'send');
      OrgFuncs.Arr[19] :=  GetProcAddress(hl, 'sendto');
      OrgFuncs.Arr[20] :=  GetProcAddress(hl, 'setsockopt');
      OrgFuncs.Arr[21] :=  GetProcAddress(hl, 'shutdown');
      OrgFuncs.Arr[22] :=  GetProcAddress(hl, 'socket');
      OrgFuncs.Arr[23] :=  GetProcAddress(hl, 'MigrateWinsockConfiguration');
      OrgFuncs.Arr[24] :=  GetProcAddress(hl, 'gethostbyaddr');
      OrgFuncs.Arr[25] :=  GetProcAddress(hl, 'gethostbyname');
      OrgFuncs.Arr[26] :=  GetProcAddress(hl, 'getprotobyname');
      OrgFuncs.Arr[27] :=  GetProcAddress(hl, 'getprotobynumber');
      OrgFuncs.Arr[28] :=  GetProcAddress(hl, 'getservbyname');
      OrgFuncs.Arr[29] :=  GetProcAddress(hl, 'getservbyport');
      OrgFuncs.Arr[30] :=  GetProcAddress(hl, 'gethostname');
      OrgFuncs.Arr[31] :=  GetProcAddress(hl, 'WSAAsyncSelect');
      OrgFuncs.Arr[32] :=  GetProcAddress(hl, 'WSAAsyncGetHostByAddr');
      OrgFuncs.Arr[33] :=  GetProcAddress(hl, 'WSAAsyncGetHostByName');
      OrgFuncs.Arr[34] :=  GetProcAddress(hl, 'WSAAsyncGetProtoByNumber');
      OrgFuncs.Arr[35] :=  GetProcAddress(hl, 'WSAAsyncGetProtoByName');
      OrgFuncs.Arr[36] :=  GetProcAddress(hl, 'WSAAsyncGetServByPort');
      OrgFuncs.Arr[37] :=  GetProcAddress(hl, 'WSAAsyncGetServByName');
      OrgFuncs.Arr[38] :=  GetProcAddress(hl, 'WSACancelAsyncRequest');
      OrgFuncs.Arr[39] :=  GetProcAddress(hl, 'WSASetBlockingHook');
      OrgFuncs.Arr[40] :=  GetProcAddress(hl, 'WSAUnhookBlockingHook');
      OrgFuncs.Arr[41] :=  GetProcAddress(hl, 'WSAGetLastError');
      OrgFuncs.Arr[42] :=  GetProcAddress(hl, 'WSASetLastError');
      OrgFuncs.Arr[43] :=  GetProcAddress(hl, 'WSACancelBlockingCall');
      OrgFuncs.Arr[44] :=  GetProcAddress(hl, 'WSAIsBlocking');
      OrgFuncs.Arr[45] :=  GetProcAddress(hl, 'WSAStartup');
      OrgFuncs.Arr[46] :=  GetProcAddress(hl, 'WSACleanup');
      OrgFuncs.Arr[47] :=  GetProcAddress(hl, '__WSAFDIsSet');
      OrgFuncs.Arr[48] :=  GetProcAddress(hl, 'WEP');
      OrgFuncs.Arr[49] :=  GetProcAddress(hl, 'WSApSetPostRoutine');
      OrgFuncs.Arr[50] :=  GetProcAddress(hl, 'inet_network');
      OrgFuncs.Arr[51] :=  GetProcAddress(hl, 'getnetbyname');
      OrgFuncs.Arr[52] :=  GetProcAddress(hl, 'rcmd');
      OrgFuncs.Arr[53] :=  GetProcAddress(hl, 'rexec');
      OrgFuncs.Arr[54] :=  GetProcAddress(hl, 'rresvport');
      OrgFuncs.Arr[55] :=  GetProcAddress(hl, 'sethostname');
      OrgFuncs.Arr[56] :=  GetProcAddress(hl, 'dn_expand');
      OrgFuncs.Arr[57] :=  GetProcAddress(hl, 'WSARecvEx');
      OrgFuncs.Arr[58] :=  GetProcAddress(hl, 's_perror');
      OrgFuncs.Arr[59] :=  GetProcAddress(hl, 'GetAddressByNameA');
      OrgFuncs.Arr[60] :=  GetProcAddress(hl, 'GetAddressByNameW');
      OrgFuncs.Arr[61] :=  GetProcAddress(hl, 'EnumProtocolsA');
      OrgFuncs.Arr[62] :=  GetProcAddress(hl, 'EnumProtocolsW');
      OrgFuncs.Arr[63] :=  GetProcAddress(hl, 'GetTypeByNameA');
      OrgFuncs.Arr[64] :=  GetProcAddress(hl, 'GetTypeByNameW');
      OrgFuncs.Arr[65] :=  GetProcAddress(hl, 'GetNameByTypeA');
      OrgFuncs.Arr[66] :=  GetProcAddress(hl, 'GetNameByTypeW');
      OrgFuncs.Arr[67] :=  GetProcAddress(hl, 'SetServiceA');
      OrgFuncs.Arr[68] :=  GetProcAddress(hl, 'SetServiceW');
      OrgFuncs.Arr[69] :=  GetProcAddress(hl, 'GetServiceA');
      OrgFuncs.Arr[70] :=  GetProcAddress(hl, 'GetServiceW');
      OrgFuncs.Arr[71] :=  GetProcAddress(hl, 'NPLoadNameSpaces');
      OrgFuncs.Arr[72] :=  GetProcAddress(hl, 'TransmitFile');
      OrgFuncs.Arr[73] :=  GetProcAddress(hl, 'AcceptEx');
      OrgFuncs.Arr[74] :=  GetProcAddress(hl, 'GetAcceptExSockaddrs');

    end;

    DLL_PROCESS_DETACH:
    begin
      FreeLibrary(hl);
    end;
  end;
end;

// accept
procedure __E__0__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 0]
end;


// bind
procedure __E__1__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 1]
end;


// closesocket
procedure __E__2__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 2]
end;


// connect
procedure __E__3__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 3]
end;


// getpeername
procedure __E__4__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 4]
end;


// getsockname
procedure __E__5__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 5]
end;


// getsockopt
procedure __E__6__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 6]
end;


// htonl
procedure __E__7__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 7]
end;


// htons
procedure __E__8__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 8]
end;


// inet_addr
procedure __E__9__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 9]
end;


// inet_ntoa
procedure __E__10__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 10]
end;


// ioctlsocket
procedure __E__11__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 11]
end;


// listen
procedure __E__12__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 12]
end;


// ntohl
procedure __E__13__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 13]
end;


// ntohs
procedure __E__14__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 14]
end;


// recv
procedure __E__15__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 15]
end;


// recvfrom
procedure __E__16__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 16]
end;


// select
procedure __E__17__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 17]
end;


// send
procedure __E__18__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 18]
end;


// sendto
procedure __E__19__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 19]
end;


// setsockopt
procedure __E__20__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 20]
end;


// shutdown
procedure __E__21__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 21]
end;


// socket
procedure __E__22__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 22]
end;


// MigrateWinsockConfiguration
procedure __E__23__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 23]
end;


// gethostbyaddr
procedure __E__24__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 24]
end;


// gethostbyname
procedure __E__25__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 25]
end;


// getprotobyname
procedure __E__26__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 26]
end;


// getprotobynumber
procedure __E__27__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 27]
end;


// getservbyname
procedure __E__28__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 28]
end;


// getservbyport
procedure __E__29__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 29]
end;


// gethostname
procedure __E__30__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 30]
end;


// WSAAsyncSelect
procedure __E__31__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 31]
end;


// WSAAsyncGetHostByAddr
procedure __E__32__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 32]
end;


// WSAAsyncGetHostByName
procedure __E__33__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 33]
end;


// WSAAsyncGetProtoByNumber
procedure __E__34__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 34]
end;


// WSAAsyncGetProtoByName
procedure __E__35__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 35]
end;


// WSAAsyncGetServByPort
procedure __E__36__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 36]
end;


// WSAAsyncGetServByName
procedure __E__37__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 37]
end;


// WSACancelAsyncRequest
procedure __E__38__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 38]
end;


// WSASetBlockingHook
procedure __E__39__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 39]
end;


// WSAUnhookBlockingHook
procedure __E__40__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 40]
end;


// WSAGetLastError
procedure __E__41__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 41]
end;


// WSASetLastError
procedure __E__42__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 42]
end;


// WSACancelBlockingCall
procedure __E__43__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 43]
end;


// WSAIsBlocking
procedure __E__44__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 44]
end;


// WSAStartup
procedure __E__45__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 45]
end;


// WSACleanup
procedure __E__46__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 46]
end;


// __WSAFDIsSet
procedure __E__47__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 47]
end;


// WEP
procedure __E__48__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 48]
end;


// WSApSetPostRoutine
procedure __E__49__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 49]
end;


// inet_network
procedure __E__50__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 50]
end;


// getnetbyname
procedure __E__51__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 51]
end;


// rcmd
procedure __E__52__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 52]
end;


// rexec
procedure __E__53__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 53]
end;


// rresvport
procedure __E__54__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 54]
end;


// sethostname
procedure __E__55__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 55]
end;


// dn_expand
procedure __E__56__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 56]
end;


// WSARecvEx
procedure __E__57__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 57]
end;


// s_perror
procedure __E__58__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 58]
end;


// GetAddressByNameA
procedure __E__59__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 59]
end;


// GetAddressByNameW
procedure __E__60__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 60]
end;


// EnumProtocolsA
procedure __E__61__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 61]
end;


// EnumProtocolsW
procedure __E__62__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 62]
end;


// GetTypeByNameA
procedure __E__63__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 63]
end;


// GetTypeByNameW
procedure __E__64__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 64]
end;


// GetNameByTypeA
procedure __E__65__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 65]
end;


// GetNameByTypeW
procedure __E__66__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 66]
end;


// SetServiceA
procedure __E__67__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 67]
end;


// SetServiceW
procedure __E__68__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 68]
end;


// GetServiceA
procedure __E__69__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 69]
end;


// GetServiceW
procedure __E__70__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 70]
end;


// NPLoadNameSpaces
procedure __E__71__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 71]
end;


// TransmitFile
procedure __E__72__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 72]
end;


// AcceptEx
procedure __E__73__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 73]
end;


// GetAcceptExSockaddrs
procedure __E__74__();
asm
  jmp [OrgFuncs.Base + SIZE_OF_FUNC * 74]
end;




//-------- Exports
exports
  __E__0__ index 1 name 'accept',
  __E__1__ index 2 name 'bind',
  __E__2__ index 3 name 'closesocket',
  __E__3__ index 4 name 'connect',
  __E__4__ index 5 name 'getpeername',
  __E__5__ index 6 name 'getsockname',
  __E__6__ index 7 name 'getsockopt',
  __E__7__ index 8 name 'htonl',
  __E__8__ index 9 name 'htons',
  __E__9__ index 10 name 'inet_addr',
  __E__10__ index 11 name 'inet_ntoa',
  __E__11__ index 12 name 'ioctlsocket',
  __E__12__ index 13 name 'listen',
  __E__13__ index 14 name 'ntohl',
  __E__14__ index 15 name 'ntohs',
  __E__15__ index 16 name 'recv',
  __E__16__ index 17 name 'recvfrom',
  __E__17__ index 18 name 'select',
  __E__18__ index 19 name 'send',
  __E__19__ index 20 name 'sendto',
  __E__20__ index 21 name 'setsockopt',
  __E__21__ index 22 name 'shutdown',
  __E__22__ index 23 name 'socket',
  __E__23__ index 24 name 'MigrateWinsockConfiguration',
  __E__24__ index 51 name 'gethostbyaddr',
  __E__25__ index 52 name 'gethostbyname',
  __E__26__ index 53 name 'getprotobyname',
  __E__27__ index 54 name 'getprotobynumber',
  __E__28__ index 55 name 'getservbyname',
  __E__29__ index 56 name 'getservbyport',
  __E__30__ index 57 name 'gethostname',
  __E__31__ index 101 name 'WSAAsyncSelect',
  __E__32__ index 102 name 'WSAAsyncGetHostByAddr',
  __E__33__ index 103 name 'WSAAsyncGetHostByName',
  __E__34__ index 104 name 'WSAAsyncGetProtoByNumber',
  __E__35__ index 105 name 'WSAAsyncGetProtoByName',
  __E__36__ index 106 name 'WSAAsyncGetServByPort',
  __E__37__ index 107 name 'WSAAsyncGetServByName',
  __E__38__ index 108 name 'WSACancelAsyncRequest',
  __E__39__ index 109 name 'WSASetBlockingHook',
  __E__40__ index 110 name 'WSAUnhookBlockingHook',
  __E__41__ index 111 name 'WSAGetLastError',
  __E__42__ index 112 name 'WSASetLastError',
  __E__43__ index 113 name 'WSACancelBlockingCall',
  __E__44__ index 114 name 'WSAIsBlocking',
  __E__45__ index 115 name 'WSAStartup',
  __E__46__ index 116 name 'WSACleanup',
  __E__47__ index 151 name '__WSAFDIsSet',
  __E__48__ index 500 name 'WEP',
  __E__49__ index 1000 name 'WSApSetPostRoutine',
  __E__50__ index 1100 name 'inet_network',
  __E__51__ index 1101 name 'getnetbyname',
  __E__52__ index 1102 name 'rcmd',
  __E__53__ index 1103 name 'rexec',
  __E__54__ index 1104 name 'rresvport',
  __E__55__ index 1105 name 'sethostname',
  __E__56__ index 1106 name 'dn_expand',
  __E__57__ index 1107 name 'WSARecvEx',
  __E__58__ index 1108 name 's_perror',
  __E__59__ index 1109 name 'GetAddressByNameA',
  __E__60__ index 1110 name 'GetAddressByNameW',
  __E__61__ index 1111 name 'EnumProtocolsA',
  __E__62__ index 1112 name 'EnumProtocolsW',
  __E__63__ index 1113 name 'GetTypeByNameA',
  __E__64__ index 1114 name 'GetTypeByNameW',
  __E__65__ index 1115 name 'GetNameByTypeA',
  __E__66__ index 1116 name 'GetNameByTypeW',
  __E__67__ index 1117 name 'SetServiceA',
  __E__68__ index 1118 name 'SetServiceW',
  __E__69__ index 1119 name 'GetServiceA',
  __E__70__ index 1120 name 'GetServiceW',
  __E__71__ index 1130 name 'NPLoadNameSpaces',
  __E__72__ index 1140 name 'TransmitFile',
  __E__73__ index 1141 name 'AcceptEx',
  __E__74__ index 1142 name 'GetAcceptExSockaddrs';


begin
  DllProc := __DLLProc;
  __DLLProc(DLL_PROCESS_ATTACH);
end.
